package mki.xml2csv.access;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import mki.xml2csv.model.Xml2CsvConfigModel;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

/**
 * XMLCSVϊpSAXDefaultHandlerNX
 * Config_XML2CSV̌Âo[WŎgp
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvSax extends DefaultHandler {
    private ByteArrayOutputStream baosIn = null;
    /**
     * ϊCSVf[^
     */
    public InputStream istream = null;
    /**
     * ItOiItruej
     */
    public boolean endFlag = false;
    //public String recordTag = null;
    private String[] field = null;
    private int[] index = null;
    private String[] csvfield = null;
    private String[] csvtype = null;
    /**
     * `񃂃f
     */
    public Xml2CsvConfigModel config = null;
    private boolean recFlag = false;
    private String[] rec = null;
    private String[] rec2 = null;
    private String element = null;
    private String deimiter = ",";
    //private String deimiter = "\t";
    private String value = null;
    /**
     * JntOiPڂtrueݒ肷j
     */
    public boolean firstFlag = false;
    private String[] multi = null;
    private HashMap multimap = new HashMap();
    private HashMap mapMultiData = new HashMap();
    private int[] multiidx = null;
    //private int[] tagcount = null;
    private HashMap tagcount = new HashMap();
    private String path = "";

    public Xml2CsvSax() {
        //ϊ̃f[^InputStreamɕϊ
        baosIn = new ByteArrayOutputStream();
        //baosIn.write(sb.toString().getBytes());
        //InputStream is2 = new ByteArrayInputStream( baosIn.toByteArray() );
    }
    /**
     * hLgJn
     */
    public void startDocument() {
        System.out.println("hLgJn");
        rec = new String[this.config.lstFields.size()];
        rec2 = new String[this.config.lstFields.size()];
        //tagcount = new int[this.config.lstFields.size()];
        //rec = new String[field.length];
        //rec2 = new String[field.length];
        //for(int i=0;i<field.length;i++){
        //	System.out.println("field["+i+"]="+field[i]);
        //}
        //}`IJXꍇ
        if (this.config.multioccurrence != null) {
            StringTokenizer st =
                new StringTokenizer(this.config.multioccurrence, ",");
            multi = new String[st.countTokens()];
            multiidx = new int[st.countTokens()];

            int i = 0;
            while (st.hasMoreTokens()) {
                String val = st.nextToken();
                //List lst = new ArrayList();
                //multimap.put(val,lst);
                multi[i] = val;
                i++;
                String[] strArray = (String[]) this.config.mapMulti.get(val);
                System.out.println("val:" + val + "strArray=" + strArray);
                //for(int j=0;j<strArray.length;j++){
                //	System.out.println("val:" + val + "strArray[" + j + "]="+strArray[j]);
                //}
                String[] m_ary = new String[strArray.length];
                mapMultiData.put(val, m_ary);
            }
        }

        field = new String[this.config.lstFields.size()];
        index = new int[this.config.lstFields.size()];
        csvfield = new String[this.config.lstFields.size()];
        if (config.typeFlag)
            csvtype = new String[this.config.lstFields.size()];
        Iterator it = this.config.lstFields.iterator();
        int m = 0;
        while (it.hasNext()) {
            String[] str = (String[]) it.next();
            field[m] = str[0];
            index[m] = Integer.parseInt(str[1]);
            //System.out.println("field[m]:" + field[m]);
            //System.out.println("index[m]:" + index[m]);
            csvfield[m] = str[2];
            if (config.typeFlag)
                csvtype[m] = str[3];
            //}`IJXꍇ
            if (this.config.multioccurrence != null) {
                for (int j = 0; j < multi.length; j++) {
                    if (field[m].equals(multi[j])) {
                        multiidx[j] = m;
                        break;
                    }
                }
            }
            m++;
        }
        try {
            String str = "";
            if (firstFlag) {
                str = ArrayToString(csvfield, deimiter);
                str = str + "\r\n";
                if (config.typeFlag) {
                    str = str + ArrayToString(csvtype, deimiter);
                    str = str + "\r\n";
                }
                baosIn.write(str.getBytes());
            }
        } catch (Exception e) {
            System.out.println("e = " + e);
            e.printStackTrace();
        }
    }
    /**
     * vf̊Jn^Oǂݍݎ
     */
    public void startElement(
        String uri,
        String localName,
        String qName,
        Attributes attributes) {
        //System.out.println("vfJn:" + qName);

        if (qName.equals("Query-Results"))
            return;

        if (path.equals("")) {
            path = qName;
        } else {
            path = path + "/" + qName;
        }
        //path = path + "/" + qName;

        //path = path + "," + qName;

        //System.out.println("Jn^Opath="+path);
        //^Ȍo񐔂JEg
        String str = (String) tagcount.get(path);
        //String str = (String)tagcount.get(qName);
        //System.out.println("###########str = " + str);
        if (str == null) {
            tagcount.put(path, "1");
            //tagcount.put(qName,"1");
        } else {
            int cnt = Integer.parseInt(str);
            tagcount.put(path, String.valueOf(cnt + 1));
            //tagcount.put(qName,String.valueOf(cnt + 1));
        }
        value = "";
        element = qName;
        if (path.endsWith(this.config.getStrRecordTag())) {
            //if(qName.equals(this.config.strRecordTag)){
            recFlag = true;
            //System.out.println("recFlag1 = " + recFlag);
            for (int k = 0; k < rec.length; k++) {
                rec2[k] = rec[k];
                //System.out.println("rec2[" + k + "] = " + rec2[k]);
            }
            /*for(int i=0;i<this.config.lstFields.size();i++){
            	tagcount[i] = 0;
            }*/
            //}`IJXꍇ
            if (this.config.multioccurrence != null
                && tagcount.get(path).equals("1")) {
                //if(this.config.multioccurrence != null && tagcount.get(qName).equals("1")){
                for (int k = 0; k < multi.length; k++) {
                    List lst = new ArrayList();
                    multimap.put(multi[k], lst);
                }
            }
        }
        //
        for (int j = 0; j < field.length; j++) {
            int pos = field[j].indexOf("@");
            if (pos != -1) {
                String atr = field[j].substring(pos + 1);
                for (int m = 0; m < attributes.getLength(); m++) {
                    if (atr.equals(attributes.getQName(m))) {
                        String tag = field[j].substring(0, pos - 1);
                        //System.out.println("tag = " + tag);
                        //System.out.println("path = " + path);
                        if (tag.endsWith(path))
                            rec[j] = attributes.getValue(m).trim();
                    }
                }
            }
            /*
            if(field[j].startsWith(qName)){
            	int pos = field[j].indexOf("@");
            	if(pos != -1){
            		String atr = field[j].substring(pos+1);
            		for(int m=0;m<attributes.getLength();m++){
            			if(atr.equals(attributes.getQName(m))){
            				rec[j] = attributes.getValue(m).trim();
            			}
            		}
            	}
            }*/
        }
    }
    /**
     * eLXgf[^ǂݍݎ
     */
    public void characters(char[] ch, int offset, int length) {

        //System.out.println("eLXgf[^F" + new String(ch, offset, length));
        value = value + new String(ch, offset, length);
    }
    /**
     * vf̏I^Oǂݍݎ
     */
    public void endElement(String uri, String localName, String qName) {

        //System.out.println("vfI:" + qName);
        if (qName.equals("Query-Results"))
            return;
        int cnt = 0;
        /*
        if(tagcount.get(qName)!=null){
        	cnt = Integer.parseInt((String)tagcount.get(qName));
        }*/
        if (tagcount.get(path) != null) {
            cnt = Integer.parseInt((String) tagcount.get(path));
        }
        int count = 1;
        boolean flag = true;
        //eLXg
        for (int j = 0; j < field.length; j++) {
            if (field[j].endsWith(path)) {
                //if(field[j].equals(qName)){
                //System.out.println("l:" + value);
                //if(!recFlag || rec[j]==null)
                //if(!recFlag || count >= cnt)
                if (!recFlag || index[j] == cnt) {
                    rec[j] = value.trim();
                    //System.out.println("rec[" + j + "] = " + rec[j]);
                    //System.out.println("j:" + j);
                    //System.out.println("index[j]:" + index[j]);
                    //System.out.println("rec[j]:" + rec[j]);
                }
                //}`IJXꍇ
                if (this.config.multioccurrence != null && flag) {
                    for (int k = 0; k < multi.length; k++) {
                        if (multi[k].endsWith(path)) {
                            //if(multi[k].equals(qName)){
                            List lst = (List) multimap.get(multi[k]);
                            //List lst = (List)multimap.get(qName);
                            lst.add(value.trim());
                            flag = false;
                        }
                    }
                }
                count++;
            }
        }
        //System.out.println("I^Opath="+path);
        //System.out.println("***path="+path);
        //R[h^ȌI
        if (path.endsWith(this.config.getStrRecordTag())) {
            //if(qName.equals(this.config.strRecordTag)){
            recFlag = false;
            //System.out.println("recFlag2 = " + recFlag);
            //Object[] objKey=tagcount.keySet().toArray();
            //System.out.println("####objKey.length = " + objKey.length);
            //for(int i=0;i<objKey.length;i++){
            //	System.out.println("key:" + objKey[i] + ",value:" + tagcount.get(objKey[i]));
            //}
            tagcount.clear();
            List lstData = new ArrayList();
            //}`IJXꍇ
            if (this.config.multioccurrence != null) {
                String[] recdata = new String[multi.length];
                setMultiData(multimap, multi, 0, recdata, lstData);
                Iterator it2 = lstData.iterator();
                while (it2.hasNext()) {
                    String[] str = (String[]) it2.next();
                    for (int n = 0; n < str.length; n++) {
                        System.out.println("}`:str[" + n + "]=" + str[n]);
                    }
                }
                /*System.out.println("########################");

                for(int k=0;k<multi.length;k++){
                	List lst = (List)multimap.get(multi[k]);
                	Iterator it = lst.iterator();
                	while(it.hasNext()){
                		System.out.println("}`IJX:" + it.next());
                	}
                }
                for(int k=0;k<multiidx.length;k++){
                	System.out.println("multiidx:" + multiidx[k]);
                }*/

                Iterator it3 = lstData.iterator();
                System.out.println("lstData.size():" + lstData.size());
                if (lstData.size() != 0) {
                    int a = 0;
                    while (it3.hasNext()) {
                        //System.out.println(a++);
                        String[] ary = (String[]) it3.next();
                        for (int k = 0; k < multi.length; k++) {
                            //rec[multiidx[k]]=ary[k];
                            for (int j = 0; j < rec.length; j++) {
                                if (multi[k].equals(field[j])
                                    && index[j] == 1) {
                                    rec[j] = ary[k];
                                } else if (
                                    multi[k].equals(field[j])
                                        && index[j] != 1) {
                                    rec[j] = "";
                                }
                            }
                        }
                        String str = ArrayToString(rec, deimiter);
                        str = str + "\r\n";
                        try {
                            baosIn.write(str.getBytes());
                        } catch (Exception e) {
                            System.out.println("e = " + e);
                            e.printStackTrace();
                        }
                    }
                } else {
                    String str = ArrayToString(rec, deimiter);
                    str = str + "\r\n";
                    try {
                        baosIn.write(str.getBytes());
                    } catch (Exception e) {
                        System.out.println("e = " + e);
                        e.printStackTrace();
                    }
                }
                //}`IJXȂꍇ
            } else {
                String str = ArrayToString(rec, deimiter);
                str = str + "\r\n";
                try {
                    baosIn.write(str.getBytes());
                } catch (Exception e) {
                    System.out.println("e = " + e);
                    e.printStackTrace();
                }
            }
            for (int k = 0; k < rec.length; k++) {
                rec[k] = rec2[k];
            }
        }
        if (path.endsWith(qName)) {
            if (path.indexOf("/") == -1) {
                path = path.substring(0, path.length() - qName.length());
            } else {
                path = path.substring(0, path.length() - qName.length() - 1);
            }
        }
    }
    /**
     * hLgI
     */
    public void endDocument() {
        System.out.println("hLgI");
        endFlag = true;
        istream = new ByteArrayInputStream(baosIn.toByteArray());
    }
    /**
     * @param array
     * @param deim
     * @return
     */
    private String ArrayToString(String[] array, String deim) {
        String str = null;
        for (int i = 0; i < array.length; i++) {
            String str2 = array[i];
            if (str2 == null)
                str2 = "";
            if (i == 0) {
                str = str2;
            } else {
                str = str + deim + str2;
            }
        }
        return str;
    }
    private void setMultiData(
        HashMap map,
        String[] str,
        int i,
        String[] rec,
        List data) {
        //System.out.println("str[i] = " + str[i]);
        List lst = (List) map.get(str[i]);
        Iterator it = lst.iterator();
        while (it.hasNext()) {
            rec[i] = (String) it.next();
            System.out.println("rec[" + i + "] = " + rec[i]);
            if (i < str.length - 1) {
                setMultiData(map, str, i + 1, rec, data);
            } else {
                String[] rec2 = new String[rec.length];
                for (int k = 0; k < rec.length; k++) {
                    rec2[k] = rec[k];
                }
                data.add(rec2);
            }
        }
    }
}
