package mki.xml2csv.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Config_XML2CSVݒDialog
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvConditionDialog extends JDialog {
  private JPanel panel1 = new JPanel();
  private JPanel jPanel1 = new JPanel();
  private JComboBox cmbAndOr = new JComboBox();
  private JTextField txtNode = new JTextField();
  private JComboBox cmbFunc = new JComboBox();
  private JComboBox cmbEq = new JComboBox();
  private JTextField txtValue = new JTextField();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabel3 = new JLabel();
  private JButton btnCancel = new JButton();
  private JButton btnOk = new JButton();
  /**
   * OK{^NbNꂽꍇtrueԂ
   */
  public boolean okFlag = false;

  /**
   * AsR{{bNXGetter
   *
   * @return JComboBox
   */
  public JComboBox getCmbEq() {
    return cmbEq;
  }

  /**
   * m[heLXgtB[hGetter
   *
   * @return JComboBox
   */
  public JTextField getTxtNode() {
    return txtNode;
  }

  /**
   * leLXgtB[hGetter
   *
   * @return JComboBox
   */
  public JTextField getTxtValue() {
    return txtValue;
  }

  /**
   * ֐R{{bNXGetter
   *
   * @return JComboBox
   */
  public JComboBox getCmbFunc() {
    return cmbFunc;
  }

  /**
   * AndAOrR{{bNXGetter
   *
   * @return JComboBox
   */
  public JComboBox getCmbAndOr() {
    return cmbAndOr;
  }

  /**
   * RXgN^
   *
   * @param frame Frame
   * @param title String
   * @param modal boolean
   */
  public Xml2CsvConditionDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
      txtNode.setEditable(false);
      DefaultComboBoxModel cmodel = new DefaultComboBoxModel();
      cmodel.addElement("");
      cmodel.addElement("and");
      cmodel.addElement("or");
      cmbAndOr.setModel(cmodel);
      DefaultComboBoxModel tmodel = new DefaultComboBoxModel();
      tmodel.addElement("");
      tmodel.addElement("contains");
      tmodel.addElement("starts-with");
      tmodel.addElement("ends-with");
      //tmodel.addElement("position");
      tmodel.addElement("integer");
      tmodel.addElement("double");
      tmodel.addElement("upper-case");
      tmodel.addElement("lower-case");
      cmbFunc.setModel(tmodel);
      DefaultComboBoxModel fmodel = new DefaultComboBoxModel();
      fmodel.addElement("=");
      fmodel.addElement("!=");
      fmodel.addElement(">=");
      fmodel.addElement(">");
      fmodel.addElement("<");
      fmodel.addElement("<=");
      cmbEq.setModel(fmodel);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * RXgN^
   */
  public Xml2CsvConditionDialog() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(null);
    jPanel1.setBorder(BorderFactory.createLineBorder(Color.black));
    jPanel1.setBounds(new Rectangle(20, 34, 549, 64));
    jPanel1.setLayout(null);
    cmbAndOr.setBounds(new Rectangle(12, 34, 56, 19));
    txtNode.setText("");
    txtNode.setBounds(new Rectangle(74, 34, 155, 20));
    cmbFunc.setBounds(new Rectangle(236, 34, 90, 19));
    cmbEq.setBounds(new Rectangle(331, 34, 66, 19));
    txtValue.setToolTipText("");
    txtValue.setText("");
    txtValue.setBounds(new Rectangle(404, 34, 131, 20));
    jLabel1.setText("m[h");
    jLabel1.setBounds(new Rectangle(77, 12, 74, 15));
    jLabel2.setText("֐");
    jLabel2.setBounds(new Rectangle(237, 14, 65, 15));
    jLabel3.setText("l");
    jLabel3.setBounds(new Rectangle(403, 12, 88, 15));
    btnCancel.setBounds(new Rectangle(455, 118, 110, 23));
    btnCancel.setText("LZ");
    btnCancel.addActionListener(new Xml2CsvConditionDialog_btnCancel_actionAdapter(this));
    btnOk.setBounds(new Rectangle(340, 118, 100, 23));
    btnOk.setText("OK");
    btnOk.addActionListener(new Xml2CsvConditionDialog_btnOk_actionAdapter(this));
    this.setResizable(false);
    getContentPane().add(panel1);
    jPanel1.add(cmbAndOr, null);
    jPanel1.add(txtNode, null);
    jPanel1.add(txtValue, null);
    jPanel1.add(jLabel3, null);
    jPanel1.add(cmbEq, null);
    jPanel1.add(cmbFunc, null);
    jPanel1.add(jLabel2, null);
    jPanel1.add(jLabel1, null);
    panel1.add(btnCancel, null);
    panel1.add(btnOk, null);
    panel1.add(jPanel1, null);
  }

  /**
   * OK{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnOk_actionPerformed(ActionEvent e) {
    if(cmbAndOr.isEnabled() && cmbAndOr.getSelectedItem().equals("")){
      MessageDialog.showWarningMessage(this, "and ܂ or IĂ","");
      return;
    }
    if(txtValue.getText().equals("")){
      MessageDialog.showWarningMessage(this, "lw肵Ă","");
      return;
    }

    okFlag = true;
    dispose();
  }

  /**
   * LZ{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnCancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  /**
   * w肳ꂽm[heLXgtB[hɐݒ肷
   *
   * @param str String
   */
  public void setNode(String str){
    txtNode.setText(str);
  }

  /**
   * 擾
   *
   * @return String
   */
  public String getCondition(){
    String func = "";

    return cmbAndOr.getSelectedItem() + txtNode.getText() + cmbEq.getSelectedItem() + txtValue.getText();
  }
}

class Xml2CsvConditionDialog_btnOk_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvConditionDialog adaptee;

  Xml2CsvConditionDialog_btnOk_actionAdapter(Xml2CsvConditionDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnOk_actionPerformed(e);
  }
}

class Xml2CsvConditionDialog_btnCancel_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvConditionDialog adaptee;

  Xml2CsvConditionDialog_btnCancel_actionAdapter(Xml2CsvConditionDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCancel_actionPerformed(e);
  }
}
