package mki.xml2csv.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Config_XML2CSVhLgꗗDialog
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvDocumentListDialog extends JDialog {
  private JPanel panel1 = new JPanel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JList lstDoc = new JList();
  private JButton btnOk = new JButton();
  private JButton btnCancel = new JButton();
  /**
   * OK{^NbNꂽꍇtrueԂ
   */
  public boolean okFlag = false;

  /**
   * RXgN^
   *
   * @param frame Frame
   * @param title String
   * @param modal boolean
   */
  public Xml2CsvDocumentListDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * RXgN^
   */
  public Xml2CsvDocumentListDialog() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(null);
    jScrollPane1.setBounds(new Rectangle(19, 19, 355, 187));
    btnOk.setBounds(new Rectangle(147, 227, 100, 23));
    btnOk.setText("OK");
    btnOk.addActionListener(new Xml2CsvDocumentListDialog_btnOk_actionAdapter(this));
    btnCancel.setBounds(new Rectangle(261, 227, 110, 23));
    btnCancel.setText("LZ");
    btnCancel.addActionListener(new Xml2CsvDocumentListDialog_btnCancel_actionAdapter(this));
    lstDoc.addMouseListener(new Xml2CsvDocumentListDialog_lstDoc_mouseAdapter(this));
    this.setResizable(false);
    getContentPane().add(panel1);
    panel1.add(jScrollPane1, null);
    panel1.add(btnCancel, null);
    panel1.add(btnOk, null);
    jScrollPane1.getViewport().add(lstDoc, null);
  }

  /**
   * OK{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnOk_actionPerformed(ActionEvent e) {
    okFlag = true;
    dispose();
  }

  /**
   * LZ{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnCancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  /**
   * hLgꗗListɏݒ
   *
   * @param model DefaultComboBoxModel
   */
  public void setListData(DefaultComboBoxModel model){
    lstDoc.setModel(model);
  }

  /**
   * IꂽhLg擾
   *
   * @return Object
   */
  public Object getSelectedDoc(){
    return lstDoc.getSelectedValue();
  }

  /**
   * List_uNbN̏
   * OK{^Ɠl̏s
   *
   * @param e ActionEvent
   */
  void lstDoc_mousePressed(MouseEvent e) {
    if(e.getClickCount()==2){
      btnOk.doClick();
    }
  }
}

class Xml2CsvDocumentListDialog_btnOk_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvDocumentListDialog adaptee;

  Xml2CsvDocumentListDialog_btnOk_actionAdapter(Xml2CsvDocumentListDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnOk_actionPerformed(e);
  }
}

class Xml2CsvDocumentListDialog_btnCancel_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvDocumentListDialog adaptee;

  Xml2CsvDocumentListDialog_btnCancel_actionAdapter(Xml2CsvDocumentListDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCancel_actionPerformed(e);
  }
}

class Xml2CsvDocumentListDialog_lstDoc_mouseAdapter extends java.awt.event.MouseAdapter {
  Xml2CsvDocumentListDialog adaptee;

  Xml2CsvDocumentListDialog_lstDoc_mouseAdapter(Xml2CsvDocumentListDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void mousePressed(MouseEvent e) {
    adaptee.lstDoc_mousePressed(e);
  }
}
