package mki.xml2csv.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.datatransfer.*;

/**
 * Config_XML2CSVXQueryDialog
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvXQueryDialog extends JDialog {
  private JPanel panel1 = new JPanel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JTextArea textareaQuery = new JTextArea();
  private JButton btnCancel = new JButton();
  private JButton btnCopy = new JButton();
  private JLabel lblMsg = new JLabel();
  private int querysize = 0;
  JLabel lblMsg0 = new JLabel();

  /**
   * QuerySizeSetter
   *
   * @param querysize int
   */
  public void setQuerysize(int querysize) {
    this.querysize = querysize;
  }

  /**
   * QuerySizeGetter
   *
   * @return int
   */
  public int getQuerysize() {
    return querysize;
  }

  /**
   * RXgN^
   *
   * @param frame Frame
   * @param title String
   * @param modal boolean
   */
  public Xml2CsvXQueryDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * RXgN^
   */
  public Xml2CsvXQueryDialog() {
    this(null, "", false);
  }
  private void jbInit() throws Exception {
    panel1.setLayout(null);
    jScrollPane1.setBounds(new Rectangle(19, 20, 454, 200));
    textareaQuery.setEnabled(true);
    textareaQuery.setForeground(Color.black);
    textareaQuery.setEditable(false);
    textareaQuery.setText("");
    textareaQuery.setLineWrap(true);
    btnCancel.setBounds(new Rectangle(363, 255, 110, 23));
    btnCancel.setText("LZ");
    btnCancel.addActionListener(new Xml2CsvXQueryDialog_btnCancel_actionAdapter(this));
    btnCopy.setBounds(new Rectangle(177, 255, 170, 23));
    btnCopy.setText("Nbv{[hփRs[");
    btnCopy.addActionListener(new Xml2CsvXQueryDialog_btnCopy_actionAdapter(this));
    this.addComponentListener(new Xml2CsvXQueryDialog_this_componentAdapter(this));
    lblMsg.setBounds(new Rectangle(19, 237, 455, 15));
    this.setResizable(false);
    lblMsg0.setBorder(null);
    lblMsg0.setText("");
    lblMsg0.setBounds(new Rectangle(19, 221, 455, 15));
    getContentPane().add(panel1);
    panel1.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(textareaQuery, null);
    panel1.add(btnCancel, null);
    panel1.add(btnCopy, null);
    panel1.add(lblMsg0, null);
    panel1.add(lblMsg, null);
  }

  /**
   * XQueryݒ肷
   *
   * @param str String
   */
  public void setXquery(String str){
    this.textareaQuery.setText(str);
    this.lblMsg0.setText("݂̃oCg" + str.getBytes().length + "oCgłB");
    if(str.getBytes().length>=querysize){
      this.lblMsg.setText(querysize + "oCgzĂꍇ͐ɓ삳Ȃ\܂B");
    }
    try{
      System.out.println("XQueryoCg=" + str.getBytes().length);
    }catch(Exception e){

    }
  }

  /**
   * LZ{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnCancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  /**
   * Nbv{[hփRs[{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnCopy_actionPerformed(ActionEvent e) {
    Clipboard cb = getToolkit().getSystemClipboard();
    StringSelection ss = new StringSelection(textareaQuery.getText());
    cb.setContents(ss, null);

    //dispose();
  }

  void this_componentShown(ComponentEvent e) {
    JViewport jv = jScrollPane1.getViewport();
    jv.setViewPosition(new Point(0,0));
  }
}

class Xml2CsvXQueryDialog_btnCancel_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvXQueryDialog adaptee;

  Xml2CsvXQueryDialog_btnCancel_actionAdapter(Xml2CsvXQueryDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCancel_actionPerformed(e);
  }
}

class Xml2CsvXQueryDialog_btnCopy_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvXQueryDialog adaptee;

  Xml2CsvXQueryDialog_btnCopy_actionAdapter(Xml2CsvXQueryDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCopy_actionPerformed(e);
  }
}

class Xml2CsvXQueryDialog_this_componentAdapter extends java.awt.event.ComponentAdapter {
  Xml2CsvXQueryDialog adaptee;

  Xml2CsvXQueryDialog_this_componentAdapter(Xml2CsvXQueryDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void componentShown(ComponentEvent e) {
    adaptee.this_componentShown(e);
  }
}
