package mki.xml2csv.access;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;

/**
 * DOMANZXNX
 * @author nagashima
 * @version 1.0
 */
public class DomAccess {
  private DocumentBuilderFactory dbfactory = null;
  private DocumentBuilder builder = null;

  /**
   * RXgN^
   */
  public DomAccess() {
    try {
      // hLgr_[t@Ng𐶐
      dbfactory = DocumentBuilderFactory.newInstance();
      // hLgr_[𐶐
      builder = dbfactory.newDocumentBuilder();
    }
    catch (Exception e) {
      System.out.println("e = " + e);
      //throw e;
    }
  }

  /**
   * w肳ꂽStringXMLhLgƂč\͂AVDOMDocumentIuWFNgԂ
   *
   * @param str XML
   * @return org.w3c.dom.Document
   */
  public Document parseString(String str) {
    Document doc = null;
    try {
      //擾XMLInputStreamɕϊ
      ByteArrayOutputStream baosIn = new ByteArrayOutputStream();
      baosIn.write(str.getBytes());
      InputStream is = new ByteArrayInputStream(baosIn.toByteArray());
      doc = parseStream(is);
    }
    catch (Exception e) {
      System.out.println("e = " + e);
      //throw e;
    }
    return doc;
  }

  /**
   * w肳ꂽStringencodingXMLhLgƂč\͂AVDOMDocumentIuWFNgԂ
   *
   * @param str XML
   * @param enc encoding
   * @return org.w3c.dom.Document
   */
  public Document parseString(String str, String enc) {
    Document doc = null;
    try {
      //擾XMLInputStreamɕϊ
      ByteArrayOutputStream baosIn = new ByteArrayOutputStream();
      baosIn.write(str.getBytes(enc));
      InputStream is = new ByteArrayInputStream(baosIn.toByteArray());
      doc = parseStream(is);
    }
    catch (Exception e) {
      System.out.println("e = " + e);
      //throw e;
    }
    return doc;
  }

  /**
   * w肳ꂽInputStreamXMLhLgƂč\͂AVDOMDocumentIuWFNgԂ
   *
   * @param is XML
   * @return org.w3c.dom.Document
   */
  public Document parseStream(InputStream is) {
    Document doc = null;
    try {
      doc = builder.parse(is);
    }
    catch (Exception e) {
      System.out.println("e = " + e);
      //throw e;
    }
    return doc;
  }

  /**
   * w肳ꂽXMLt@CXMLhLgƂč\͂AVDOMDocumentIuWFNgԂ
   *
   * @param xmlfile XMLt@C̐΃pX
   * @return org.w3c.dom.Document
   */
  public Document parseFile(String xmlfile) {
    Document doc = null;
    try {
      doc = builder.parse(xmlfile);
    }
    catch (Exception e) {
      System.out.println("e = " + e);
      //throw e;
    }
    return doc;
  }
}
